'
' Demonstrate a USB HID Mouse interface using the Proton BASIC language
'
' Moves the mouse cursor in a square pattern on the PC's desktop
'
' The demonstration is configured to use a 12MHz crystal
' This can be changed by altering the fuse setting located in the USB_Defs.inc file
'
    Device = 18F14K50
    'Device = 18F4550
    'Device = 18F87J50
    
    Declare Xtal = 48
    Declare Optimiser_Level = 3             ' Maximum optimisation
    Declare Dead_Code_Remove = On           ' Squeeze the code further

    Dim Buffer[4]   As Byte
    Dim Loop        As Byte
    Dim Position    As Byte
'
'--------------------------------------------------------------------------
    Include "Mouse_Descriptor.inc"            ' Load the USB routines and descriptor into the program   
'--------------------------------------------------------------------------
' The main program loop starts here 
Main:
    Clear Buffer
    
    While 1 = 1                                 ' Create an infinite loop
        For Position = 0 To 3                   ' Move through each position of the pattern
            For Loop = 0 To 31                  ' 32 steps in each direction
                Select Position
                    Case 0                      ' Move Up?
                        Buffer#1 = 0
                        Buffer#2 = -2
                    Case 1                      ' Move Right?
                        Buffer#1 = 2
                        Buffer#2 = 0
                    Case 2                      ' Move Down?
                        Buffer#1 = 0
                        Buffer#2 = 2
                    Case 3                      ' Move Left?
                        Buffer#1 = -2
                        Buffer#2 = 0
                EndSelect
                HID_WriteArray(Buffer,3)
                DelayMS 20
            Next
            DelayMS 20
        Next
    Wend                                        ' Do it forever
    


